#!/bin/sh -x

from=10.60.0.200

pool=`zpool list -o name -H`
log=/$pool/log/

exclude='--exclude var/cache --exclude var/lib/koha/zebradb/biblios --exclude data/webpac2/var/'

function rsync_veid() {

veid=$1
host=$2

date_time=`rsync $from::mnt/$host/.snap/ | tail -1 | awk '{ print $5 }'`
date=`echo $date_time | cut -dT -f1`

(
rsync $exclude -ravHz --numeric-ids --delete --force --modify-window=2 \
	$from::mnt/$host/.snap/$date_time/	\
	/$pool/backup/$veid/			\
&& zfs snapshot $pool/backup/$veid@$date
2>&1 ) | tee -a $log/$date.log

}

rsync_veid 212052 koha-dev
rsync_veid 212056 webpac2
rsync_veid 212226 koha

#zfs list -r $pool/backup | tee -a $log/$date.log

